/*
    DIS386 test code for C
    Copyright (c) 1994-2003,2004 Alessandro Scotti
    http://www.ascotti.org/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <stdio.h>
#include "dis386.h"

static unsigned char testcode[] = {
    0x2e,0x67,0x66,0x8b,0x84,0x99,0x34,0x12,0x00,0x00,
    0x0f,0x08,
    0x0f,0x05,
    0x0f,0xa2,
    0x0f,0x31,
    0x8e,0x3e,0x34,0x12,
    0xd6,
    0x0f,0xc7,0x04
};

void main( void )
{
    D3CONTROL   D3C;
    int         count = 0;
    char        sz[80];

    printf( "DIS386 test program\n" );
    printf( "*** Start ***\n" );

    D3C.CPtr = testcode;
    D3C.VSeg = ((long)testcode) >> 16;
    D3C.VOfs = ((long)testcode) & 0xFFFF;
    D3C.BPtr = sz;
    D3C.DumpSize = 24;
    D3C.Flags = 0;

    do {
        count += dis3_Decode( &D3C );
        printf( "%s\n", sz );
    } while( count < sizeof(testcode) );

    printf( "*** End ***\n" );
}
