(*
    DIS386 demo program
    Simple browser for COM files
    Copyright (c) 1994-2003,2004 Alessandro Scotti
    http://www.ascotti.org/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*)
{$I-,X+}
uses Crt, Dis386;

const
  BUFSIZE = 16384;
  PAGELEN = 24;
var
  Buffer : array[ 0..BUFSIZE-1 ] of byte;
  BufLen : word;
  Control: D3Control;

procedure Load( FName: string );
var
  F: file;
begin
  if( Pos( '.', FName ) = 0 ) then
    FName := FName + '.COM';
  Assign( F, FName );
  Reset( F, 1 );
  if( IOResult <> 0 ) then begin
    WriteLn( 'Error loading file.' );
    Halt;
  end;
  BlockRead( F, Buffer, BUFSIZE, BufLen );
  Close( F );
end;

procedure ToSource( FName: string );
var
  F: text;
  S: string;
  C, L, O: word;
begin
  if( Pos( '.', FName ) > 0 ) then
    Delete( FName, Pos( '.', FName ), 255 );
  for L:=1 to Length(FName) do FName[L] := UpCase(FName[L]);
  FName := FName + '.LST';
  Assign( F, FName );
  ReWrite( F );
  if( IOResult <> 0 ) then Exit;
  WriteLn( F, ';-------------------------------------' );
  WriteLn( F, '; ', FName );
  WriteLn( F, ';-------------------------------------' );
  WriteLn( F, '.MODEL TINY' );
  WriteLn( F, '.CODE' );
  WriteLn( F, '.386P' );
  WriteLn( F, '.387' );
  WriteLn( F, 'ORG 100h' );
  WriteLn( F, '' );
  WriteLn( F, 'EntryPoint:' );
  Control.Flags := (Control.Flags or D3F_SOURCE) and $FFF0;
  Control.VOfs := $100;
  Control.VSeg := Seg( Buffer );
  Control.CPtr := @Buffer;
  repeat
    L := d3Decode( Control, S );
    WriteLn( F, S );
    if( L = 0 ) then L := 1;
    Inc( O, L );
  until( O >= BufLen );
  WriteLn( F, '' );
  WriteLn( F, 'END EntryPoint' );
  Close( F );
end;

procedure Browse;
var
  Len: word;
  Offs: word;
  I, O: word;
  S: string;
  C: char;
begin
  Control.Flags := 0;
  Control.VSeg := Seg(Buffer);
  Control.CPtr := @Buffer;
  Control.DumpSize := 23;
  ClrScr;
  Offs := 0;
  repeat
  (* Status line *)
    GotoXY( 1, 25 );
    Write( #219 );
    TextAttr := $70;
    Write( 'I)ndent  S)ource  U)pcase  [ESC to exit, F saves list]   ' ); ClrEol;
    if( Control.Flags and D3F_SOURCE > 0 ) then Write( '[S]' );
    if( Control.Flags and D3F_INDENT > 0 ) then Write( '[I]' );
    if( Control.Flags and D3F_UPCASE > 0 ) then Write( '[U]' );
    TextAttr := $07;
  (* Display *)
      O := Offs;
      for I:=1 to PAGELEN do begin
        Control.VOfs := O;
        Control.CPtr := @Buffer[O];
        Len := d3Decode( Control, S );
        GotoXY( 1, I );
        Write( S ); ClrEol;
        Inc( O, Len );
      end;
      GotoXY( 1, 25 );
  (* Keyboard *)
      C := UpCase(ReadKey);
      case C of
        #00: case byte(ReadKey) of
          $50: begin
                 Control.CPtr := @Buffer[Offs];
                 Inc( Offs, d3Decode( Control, S ) );  (* Down *)
               end;
          $48: begin  (* Up *)
                 O := Offs;
                 if( O > 0 ) then repeat
                   Dec( O );
                   Control.CPtr := @Buffer[O];
                   Len := d3Decode( Control, S );
                 until( O+Len <= Offs )or( O=0 );
                 Offs := O;
               end;
          $51: Offs := O;  (* Pgdn *)
        end;
        'S': Control.Flags := Control.Flags xor D3F_SOURCE;
        'I': Control.Flags := Control.Flags xor D3F_INDENT;
        'U': Control.Flags := Control.Flags xor D3F_UPCASE;
        'F': ToSource( ParamStr(1) );
      end;
  until( C = #27 );
end;

var
  S: string;

begin
  if( ParamCount = 0 ) then begin
    WriteLn( 'Usage: VIEWCOM file[.COM]' );
    Halt;
  end;

  Load( ParamStr(1) );
  Browse;
  ClrScr;
end.
